
Summary: META package for the ORACLE instantclient
Name: oracle-instantclient
Version: 12.2
Release: 7%{?dist}
Epoch:   2
Source0: oracle-instantclient%{version}-x86_64.conf
Source1: oracle-instantclient11.2-x86_64.conf
Source2: pcscfg.cfg-%{version}.fix
License: GPL
Group: Applications/File
BuildRoot: %{_tmppath}/%{name}-root
ExclusiveArch: x86_64

# 12.2 provides 12.1 libraries ...
%define versionlib 12.1

%description
This META package provides required dependency chain


###################################   version 11.2   ###############################

%package -n oracle-instantclient11.2-meta
Summary: META package for the ORACLE instantclient 11.2
Provides: libclntsh.so.11.2()(64bit)
Provides: libocci.so.11.2()(64bit)
Provides: libnnz11.so()(64bit)
#Obsoletes: oracle-instantclient11.2
#Obsoletes: oracle-instantclient
Requires:  oracle-instantclient-tnsnames.ora

%description -n oracle-instantclient11.2-meta
This META package adds rpm provides missing in original Oracle
InstantClient packages and configures system LD_LIBRARY_PATH

%package -n oracle-instantclient11.2
Summary: META package for the ORACLE instantclient 11.2
Requires: oracle-instantclient11.2-meta

%description -n oracle-instantclient11.2
This META package adds rpm provides missing in original Oracle
InstantClient packages and configures system LD_LIBRARY_PATH

%package -n oracle-instantclient11.2-compat
Summary: compat package for the ORACLE instantclient 11.2
Requires: oracle-instantclient11.2-basic
Conflicts: oracle-instantclient11.2-devel

%description -n oracle-instantclient11.2-compat
This compat package adds unversioned libraries symbolic
links (libclntshcore.so, libocci.so, libclntsh.so) without
installing oracle-instantclient11.2-devel


%triggerin -n oracle-instantclient11.2-meta -- oracle-instantclient11.2-basic, oracle-instantclient11.2-basiclite, oracle-instantclient11.2-jdbc, oracle-instantclient11.2-odbc, oracle-instantclient11.2-sqlplus, oracle-instantclient11.2-devel, oracle-instantclient11.2-tools, oracle-instantclient11.2-precomp oracle-instantclient11.2-compat
/usr/sbin/ldconfig ||:

%triggerun -n oracle-instantclient11.2-meta -- oracle-instantclient11.2-basic, oracle-instantclient11.2-basiclite, oracle-instantclient11.2-jdbc, oracle-instantclient11.2-odbc, oracle-instantclient11.2-sqlplus, oracle-instantclient11.2-devel, oracle-instantclient11.2-tools, oracle-instantclient11.2-precomp oracle-instantclient11.2-compat
/usr/sbin/ldconfig ||:

################################### version %{version} ##################################

%package -n oracle-instantclient%{version}-meta
Summary: META package for the ORACLE instantclient %{version}
Provides: libclntsh.so.%{versionlib}()(64bit)
Provides: libocci.so.%{versionlib}()(64bit)
Provides: libnnz12.so()(64bit)
#Obsoletes: oracle-instantclient%{version}
#Obsoletes: oracle-instantclient
Requires: oracle-instantclient-tnsnames.ora

%package -n oracle-instantclient%{version}
Summary: META package for the ORACLE instantclient %{version}
Requires: oracle-instantclient%{version}-meta

%description -n oracle-instantclient%{version}
This META package adds rpm provides missing in original Oracle
InstantClient packages and configures system LD_LIBRARY_PATH

%description -n oracle-instantclient%{version}-meta
This META package adds rpm provides missing in original Oracle
InstantClient packages and configures system LD_LIBRARY_PATH

%package -n oracle-instantclient%{version}-compat
Summary: compat package for the ORACLE instantclient %{version}
Requires: oracle-instantclient%{version}-basic
Conflicts: oracle-instantclient%{version}-devel

%description -n oracle-instantclient%{version}-compat
This compat package adds unversioned libraries symbolic
links (libclntshcore.so, libocci.so, libclntsh.so) without
installing oracle-instantclient%{version}-devel

%package -n oracle-instantclient-compat
Summary: compat package for the ORACLE instantclient
Requires: oracle-instantclient-basic
Conflicts: oracle-instantclient-devel

%description -n oracle-instantclient-compat
This compat package adds unversioned libraries symbolic
links (libclntshcore.so, libocci.so, libclntsh.so) without
installing oracle-instantclient-devel

%package -n oracle-instantclient-basic
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-basic >= %{version}

%description -n oracle-instantclient-basic
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-devel
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-devel >= %{version}

%description -n oracle-instantclient-devel
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-basiclite
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-basiclite >= %{version}

%description -n oracle-instantclient-basiclite
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-jdbc
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-jdbc >= %{version}

%description -n oracle-instantclient-jdbc
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-odbc
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-odbc >= %{version}

%description -n oracle-instantclient-odbc
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-precomp
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-precomp >= %{version}

%description -n oracle-instantclient-precomp
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-tools
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-tools >= %{version}

%description -n oracle-instantclient-tools
Summary: META package for the ORACLE instantclient BASIC (latest)

%package -n oracle-instantclient-sqlplus
Summary: META package for the ORACLE instantclient (latest)
Requires: oracle-instantclient%{version}-meta
Requires: oracle-instantclient%{version}-sqlplus >= %{version}
Obsoletes: oracle-instantclient12.1-sqlplus 

%description -n oracle-instantclient-sqlplus
Summary: META package for the ORACLE instantclient BASIC (latest)

%triggerin -n oracle-instantclient%{version}-meta -- oracle-instantclient%{version}-basic, oracle-instantclient%{version}-basiclite, oracle-instantclient%{version}-jdbc, oracle-instantclient%{version}-odbc, oracle-instantclient%{version}-sqlplus, oracle-instantclient%{version}-devel, oracle-instantclient%{version}-tools, oracle-instantclient%{version}-precomp oracle-instantclient%{version}-compat
/usr/sbin/ldconfig ||:

%triggerun -n oracle-instantclient%{version}-meta -- oracle-instantclient%{version}-basic, oracle-instantclient%{version}-basiclite, oracle-instantclient%{version}-jdbc, oracle-instantclient%{version}-odbc, oracle-instantclient%{version}-sqlplus, oracle-instantclient%{version}-devel, oracle-instantclient%{version}-tools, oracle-instantclient%{version}-precomp oracle-instantclient%{version}-compat
/usr/sbin/ldconfig ||:

%install

mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d/
install -m 644 %SOURCE0 $RPM_BUILD_ROOT/etc/ld.so.conf.d/
install -m 644 %SOURCE1 $RPM_BUILD_ROOT/etc/ld.so.conf.d/

mkdir -p $RPM_BUILD_ROOT/usr/lib/oracle/%{version}/client64/lib/precomp/admin/
install -m 644 %SOURCE2 $RPM_BUILD_ROOT/usr/lib/oracle/%{version}/client64/lib/precomp/admin/

mkdir -p $RPM_BUILD_ROOT/usr/lib/oracle/%{version}/client64/lib/
pushd $RPM_BUILD_ROOT/usr/lib/oracle/%{version}/client64/lib/
ln -s libclntshcore.so.%{versionlib} libclntshcore.so
ln -s libocci.so.%{versionlib} libocci.so
ln -s libclntsh.so.%{versionlib} libclntsh.so
popd

mkdir -p $RPM_BUILD_ROOT/usr/lib/oracle/11.2/client64/lib/
pushd $RPM_BUILD_ROOT/usr/lib/oracle/11.2/client64/lib/
ln -s libocci.so.11.1 libocci.so
ln -s libclntsh.so.11.1 libclntsh.so
popd



%clean
rm -rf $RPM_BUILD_ROOT

%post -n oracle-instantclient%{version}-meta

/usr/sbin/ldconfig ||:

%post -n oracle-instantclient11.2-meta

/usr/sbin/ldconfig ||:

%postun -n oracle-instantclient%{version}-meta

/usr/sbin/ldconfig ||:

%postun -n oracle-instantclient11.2-meta

/usr/sbin/ldconfig ||:

%post -n oracle-instantclient11.2-compat

/usr/sbin/ldconfig ||:

%postun -n oracle-instantclient11.2-compat

/usr/sbin/ldconfig ||:

%post -n oracle-instantclient-precomp
/bin/cp -f  /usr/lib/oracle/%{version}/client64/lib/precomp/admin/pcscfg.cfg-%{version}.fix /usr/lib/oracle/%{version}/client64/lib/precomp/admin/pcscfg.cfg
exit 0

%triggerin -- oracle-instanclient%{version}-precomp
/bin/cp -f  /usr/lib/oracle/%{version}/client64/lib/precomp/admin/pcscfg.cfg-%{version}.fix /usr/lib/oracle/%{version}/client64/lib/precomp/admin/pcscfg.cfg
exit 0


%files -n oracle-instantclient%{version}-meta
%defattr(-,root,root)
/etc/ld.so.conf.d/oracle-instantclient%{version}-x86_64.conf

%files -n oracle-instantclient11.2-meta
%defattr(-,root,root)
/etc/ld.so.conf.d/oracle-instantclient11.2-x86_64.conf

%files -n oracle-instantclient11.2-compat
%defattr(-,root,root)
/usr/lib/oracle/11.2/client64/lib/libclntsh.so
/usr/lib/oracle/11.2/client64/lib/libocci.so

%files -n oracle-instantclient%{version}-compat
%defattr(-,root,root)
/usr/lib/oracle/%{version}/client64/lib/libclntsh.so
/usr/lib/oracle/%{version}/client64/lib/libocci.so
/usr/lib/oracle/%{version}/client64/lib/libclntshcore.so

%files -n oracle-instantclient-basic
%defattr(-,root,root)

%files -n oracle-instantclient-basiclite
%defattr(-,root,root)

%files -n oracle-instantclient-devel
%defattr(-,root,root)

%files -n oracle-instantclient-jdbc
%defattr(-,root,root)

%files -n oracle-instantclient-odbc
%defattr(-,root,root)

%files -n oracle-instantclient-precomp
%defattr(-,root,root)
/usr/lib/oracle/%{version}/client64/lib/precomp/admin/pcscfg.cfg-%{version}.fix

%files -n oracle-instantclient-sqlplus
%defattr(-,root,root)

%files -n oracle-instantclient-tools
%defattr(-,root,root)

%files -n oracle-instantclient
%defattr(-,root,root)

%files -n oracle-instantclient%{version}
%defattr(-,root,root)

%files -n oracle-instantclient11.2
%defattr(-,root,root)

%post -n oracle-instantclient%{version}-compat

/usr/sbin/ldconfig ||:

%postun -n oracle-instantclient%{version}-compat

/usr/sbin/ldconfig ||:



%changelog
* Wed Dec 20 2017 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.2-7
- fix compat package symbolic links 

* Mon Oct 09 2017 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.2-6
- fix metapackage provides.

* Fri Sep 15 2017 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.2-4
- added obsolete for oracle-instantclient12.1-sqlplus
- updated for 12.2.0.1

* Tue Jul 25 2017 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.1-12
- added -tools metapackage.

* Mon Nov 28 2016 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.1-10
- oracle-instantclient{X.Y}-compat added

* Thu Nov 24 2016 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.1-9
- triggerin/triggerun for meta packages to run ldconfig

* Thu Dec 03 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.1-7
- add post/triggerin for -precomp package settign correct pcscfg.cfg

* Thu Dec 03 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 12.1-6
- fix obsoletes/requires

* Tue Dec 01 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 1.2-1

- provide metapackages for old naming schema (oracle-instantclient-sthg)

* Thu Nov 26 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 1.1-1

- change numbering schema, repackage to allow multiple versions 
  of instantclient installs.

* Wed Nov 25 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 11.2-1
- turns out we need 11.2 too on 7

* Mon Oct 27 2014 Matthias Schroder <Matthias.Schroder@cern.ch> - %{version}-3
- enable provide for libnnz12.so

* Fri Sep 12 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - %{version}-2
- fix reqs/provs.

* Wed Sep 10 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - %{version}.0.2
- el7 initial build

